/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef DATAITEMWIDGETHEADERFILE
#define DATAITEMWIDGETHEADERFILE

#include <QWidget>

class QLabel;
class QLineEdit;

class TDataItemWidget : public QWidget
{
Q_OBJECT

public:
	

// CREATORS
	TDataItemWidget(const int id,const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TDataItemWidget(void);

// ACCESSORS
	bool Value_Enabled(void) const;
	QString Hex_Data(void) const;

// MANIPULATORS
	void Set_Item_Width(const int width);
	void Set_Title_Width(const int width);
	void Set_Edit_Width(const int width);
	
	void Enable_Value(const bool state);
	
	void Set_Integer(const int ival);
	void Set_Hexadecimal(const int ival);
	void Set_Value(const double &dval);
	void Set_Item(const QChar item);
	void Set_Description(const QString &description);
	

signals:
	void Int_Edited(int,const QString&);	// int has control id
	void Hex_Edited(int,const QString&);	// int has control id
	void Dec_Edited(int,const QString&);	// int has control id

private slots:
	void Int_Edited(const QString&);
	void Hex_Edited(const QString&);
	void Dec_Edited(const QString&);
	
private:
	QLabel								*d_help_label;
	QLabel								*d_item_label;
	QLabel								*d_hex_label;
	QLabel								*d_int_label;
	QLabel								*d_value_label;
	QLineEdit							*d_double_value_edit;
	QLineEdit							*d_hex_value_edit;
	QLineEdit							*d_int_value_edit;
	
	int									d_id;

// NOT IMPLEMENTED
	TDataItemWidget(const TDataItemWidget&);
	TDataItemWidget& operator=(const TDataItemWidget&);
};

#endif
