/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#include <QApplication>
#include <QEvent>
#include <QKeyEvent>
#include <QDebug>

#include "globalkeyevent.h"

TGlobalKeyEvent::TGlobalKeyEvent(
	const QObject						*parent)
:QObject(const_cast<QObject*>(parent))
{
}

TGlobalKeyEvent::~TGlobalKeyEvent(void)
{
}

bool TGlobalKeyEvent::eventFilter(
	QObject								*object,
	QEvent								*event)
{
	QKeyEvent							*key_event;

	if(event->type() == QEvent::KeyPress)
	{
		key_event = static_cast<QKeyEvent*>(event);
		
		// don't send to anything without a name
		// a better way needs to be found for this
		// double key presses are sent otherwise
		if(object->objectName().length())
		{
			emit Key_Pressed(key_event->key());
		}

	}
	return QObject::eventFilter(object, event);
};
