/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef SH32DATAHEADERFILE
#define SH32DATAHEADERFILE

#include <QChar>
#include <QString>
#include <vector>

struct TSH32DataEntryItem
{
	QChar								entry_id;
	bool								can_be_value;
	QString								description;
};

struct TSH32DataEntry
{
	int									command_id;
	std::vector<TSH32DataEntryItem>		entry_items;
};


class TSH32Data
{
public:
	
// CREATORS
	TSH32Data(void);
	~TSH32Data(void);

// ACCESSORS
	TSH32DataEntry Get_Entry(const int command_id) const;
	
// MANIPULATORS
	
private:
	
// NOT IMPLEMENTED
	TSH32Data(const TSH32Data&);
	TSH32Data& operator=(const TSH32Data&);
};

#endif
